Index: /branches/height_map_merge/src/lib/graphics/importer/height_map.cc
===================================================================
--- /branches/height_map_merge/src/lib/graphics/importer/height_map.cc	(revision 6938)
+++ /branches/height_map_merge/src/lib/graphics/importer/height_map.cc	(revision 6939)
@@ -56,10 +56,11 @@
 	 // This Draws the LOD's
 	 							//FIXME
-    float cameraDistance = (State::getCamera()->getAbsCoor() - Vector(0.0,100.0,0.0)).len();
-    if (cameraDistance > 10000 )
+    float cameraDistance = (State::getCamera()->getAbsCoor() - Vector(this->x, hmref->offsetY , this->z) ).len();
+	if(cameraDistance < 0) cameraDistance = -cameraDistance;
+    if(cameraDistance > 5000 )
     {
-    
+     return;
     }
-    else if (cameraDistance >= 50000 )
+    else if (cameraDistance >= 1000 )
     {
       this->drawLowRes();
@@ -96,4 +97,9 @@
 	#define normalVectorField hm->normalVectorField
 	
+	hmref = hm; // FIXME
+	
+	this->x = hm->offsetX + (heightMap->h - ((i1+i2)/2))*scaleX;
+	this->z = hm->offsetZ + ((j1 + j2 )/2 )	* scaleZ;
+	
 	int sampleRate = Res;
 	
@@ -106,10 +112,11 @@
 
  
-PRINTF(0)("loadin * \n");
+
  
  if(heightMap != NULL && heightMap->format->BitsPerPixel == 8 )
 	
 	SDL_LockSurface(heightMap);
-
+	SDL_LockSurface(hm->colourMap);
+	
 	for(int i = i1 ; i <= i2  ; i +=sampleRate)
 	{
@@ -120,14 +127,14 @@
 		 if(hm->hasColourMap)
 		 {
-		 r = (float)colours[3*w+2 + 3*i*(heightMap->w )];
-		 g = (float)colours[3*w+1 + 3*i*(heightMap->w)];
-		 b = (float)colours[3*w+0 + 3*i*(heightMap->w)];
+		 r = colours[(3*w+2 + 3*i*(heightMap->w )) ];
+		 g = colours[(3*w+1 + 3*i*(heightMap->w)) ];
+		 b = colours[(3*w+0 + 3*i*(heightMap->w))];
 		 }
 		
 		w = j1;
 	    	model->addVertex(scaleX*(heightMap->h -i)+ shiftX,shiftY,scaleZ*(w)+ shiftZ); // Top Right
-		model->addNormal(normalVectorField[i][w].y,normalVectorField[i][w].z,normalVectorField[i][w].x);
+		model->addNormal(normalVectorField[i % heightMap->h][w % heightMap->w].y,normalVectorField[i % heightMap->h][w % heightMap->w].z,normalVectorField[i % heightMap->h][w % heightMap->w].x);
 		model->addTexCoor((float)(j1-sampleRate) /(texRate), (float)(i %heightMap->h)/(texRate));
-		PRINTF(0)("shiftX %f,shiftY %f,shiftZ %f\n", shiftX, shiftY ,shiftZ);
+		
  		model->addColor(r/255.0,g/255.0,b/255.0);
 		
@@ -135,4 +142,104 @@
 	    {
 	    
+	    
+	    	 // To be fixed
+		 if(hm->hasColourMap)
+		 {
+		 r = colours[(3*j+2 + 3*i*(heightMap->w )) ];
+		 g =  colours[(3*j+1 + 3*i*(heightMap->w)) ];
+		 b =  colours[(3*j+0 + 3*i*(heightMap->w))];
+		 }
+		height = (float)(unsigned char) hm->heights[(j +sampleRate+ i*(heightMap->w )) ];
+		height += (float)(unsigned char) hm->heights[(j+ 1 + sampleRate + (i+1)*(heightMap->w )) ];
+		height +=  (float) (unsigned char) hm->heights[(j -1+ sampleRate   + (i+1)*(heightMap->w ))];
+		height +=  (float)(unsigned char)hm->heights[(j +sampleRate+ (i+2)*(heightMap->w )) ];
+		height +=  (float)(unsigned char)hm->heights[(j+sampleRate + (i)*(heightMap->w )) ];
+		height=height/5.0;
+		
+		model->addVertex(scaleX*(heightMap->h -i) + shiftX ,((double)(height)*scaleY) + shiftY ,scaleZ*(j) + shiftZ); // Top Right	
+		model->addNormal(normalVectorField[i % heightMap->h][j % heightMap->w].y,normalVectorField[i % heightMap->h][j % heightMap->w].z,normalVectorField[i % heightMap->h][j % heightMap->w].x);
+		model->addTexCoor((float)(j) /(texRate), (float)(i %heightMap->h)/(texRate));
+		
+		//PRINTF(0)("TexCoord:  %f %f \n",(float)j / 100.0, (float)(i %heightMap->h)/100.0);
+		
+ 		model->addColor(r/255.0,g/255.0,b/255.0);
+		w = j;
+	    }
+		
+		
+		model->addVertex(scaleX*(heightMap->h -i)+ shiftX,shiftY,scaleZ*(w)+ shiftZ); // Top Right
+		model->addNormal(normalVectorField[i % heightMap->h][w % heightMap->w].y,normalVectorField[i % heightMap->h][w % heightMap->w].z,normalVectorField[i% heightMap->h][w % heightMap->w].x);
+		model->addTexCoor((float)(j2+sampleRate) /(texRate), (float)(i %heightMap->h)/(texRate));
+ 		model->addColor(r/255.0,g/255.0,b/255.0);
+		
+	}
+	
+	
+	
+
+
+	SDL_UnlockSurface(heightMap);
+	int cnt = 0;
+	for(int i = i1   ; i < i2  ; i +=sampleRate)
+	{
+		
+	    for(int j = j1-sampleRate  ; j < j2  + 2*sampleRate  ;  j += sampleRate)
+	    {
+		
+	    	model->addIndice(cnt);
+		model->addIndice(cnt  + (j2 -j1 + 3* sampleRate  )/ sampleRate );
+		cnt++;
+		
+	    }
+	    	
+	    	
+	    	
+		 model->newStripe();	
+		
+		
+	}
+	 cnt += (j2 -j1 + 3* sampleRate)/ sampleRate;
+	
+		for(int j = j1 ; j <= j2    ;  j += sampleRate)
+	    {
+	    	int i = i1;
+	    
+	    	 // To be fixed
+		 if(hm->hasColourMap)
+		 {
+		 r = (float)colours[(3*j+2 + 3*i*(heightMap->w )) ];
+		 g = (float)colours[(3*j+1 + 3*i*(heightMap->w)) ];
+		 b = (float)colours[(3*j+0 + 3*i*(heightMap->w))];
+		 }
+		
+		model->addVertex(scaleX*(heightMap->h -i) + shiftX , shiftY ,scaleZ*(j) + shiftZ); // Top Right	
+		model->addNormal(normalVectorField[i % heightMap->h][j % heightMap->w].y,normalVectorField[i % heightMap->h][j % heightMap->w].z,normalVectorField[i % heightMap->h][j % heightMap->w].x);
+		model->addTexCoor((float)j /(texRate), (float)((i - sampleRate) %heightMap->h)/(texRate));
+ 		model->addColor(r/255.0,g/255.0,b/255.0);		
+	
+	    }
+
+	        for(int j = j1  ; j <= j2    ;  j += sampleRate)
+	    {
+	    	int i = i1;
+		height = (float)(unsigned char) hm->heights[(j +sampleRate+ i*(heightMap->w )) ];
+		height += (float)(unsigned char) hm->heights[(j+ 1 + sampleRate + (i+1)*(heightMap->w )) ];
+		height +=  (float) (unsigned char) hm->heights[(j -1+ sampleRate   + (i+1)*(heightMap->w ))];
+		height +=  (float)(unsigned char)hm->heights[(j +sampleRate+ (i+2)*(heightMap->w )) ];
+		height +=  (float)(unsigned char)hm->heights[(j+sampleRate + (i)*(heightMap->w )) ];
+		height=height/5.0;
+		
+		model->addVertex(scaleX*(heightMap->h -i) + shiftX , ((double)(height)*scaleY) +shiftY ,scaleZ*(j) + shiftZ); // Top Right	
+		model->addNormal(normalVectorField[i % heightMap->h][j % heightMap->w].y,normalVectorField[i % heightMap->h][j% heightMap->w].z,normalVectorField[i%heightMap->h][j%heightMap->w].x);
+		model->addTexCoor((float)j /(texRate), (float)(i %heightMap->h)/(texRate));
+ 		model->addColor(r/255.0,g/255.0,b/255.0);
+	    
+	    }
+	    
+	        
+	    
+	    for(int j = j1  ; j <= j2    ;  j += sampleRate)
+	    {
+	    	int i = i2;
 	    
 	    	 // To be fixed
@@ -143,107 +250,7 @@
 		 b = (float)colours[3*j+0 + 3*i*(heightMap->w)];
 		 }
-		height = (float)(unsigned char) hm->heights[j +sampleRate+ i*(heightMap->w )];
-		height += (float)(unsigned char) hm->heights[j+ 1 + sampleRate + (i+1)*(heightMap->w )];
-		height +=  (float) (unsigned char) hm->heights[j -1+ sampleRate   + (i+1)*(heightMap->w )];
-		height +=  (float)(unsigned char)hm->heights[j +sampleRate+ (i+2)*(heightMap->w )];
-		height +=  (float)(unsigned char)hm->heights[j+sampleRate + (i)*(heightMap->w )];
-		height=height/5.0;
-		
-		model->addVertex(scaleX*(heightMap->h -i) + shiftX ,((double)(height)*scaleY) + shiftY ,scaleZ*(j) + shiftZ); // Top Right	
-		model->addNormal(normalVectorField[i][j].y,normalVectorField[i][j].z,normalVectorField[i][j].x);
-		model->addTexCoor((float)(j) /(texRate), (float)(i %heightMap->h)/(texRate));
-		
-		//PRINTF(0)("TexCoord:  %f %f \n",(float)j / 100.0, (float)(i %heightMap->h)/100.0);
-		
- 		model->addColor(r/255.0,g/255.0,b/255.0);
-		w = j;
-	    }
-		
-		
-		model->addVertex(scaleX*(heightMap->h -i)+ shiftX,shiftY,scaleZ*(w)+ shiftZ); // Top Right
-		model->addNormal(normalVectorField[i][w].y,normalVectorField[i][w].z,normalVectorField[i][w].x);
-		model->addTexCoor((float)(j2+sampleRate) /(texRate), (float)(i %heightMap->h)/(texRate));
- 		model->addColor(r/255.0,g/255.0,b/255.0);
-		
-	}
-	
-	
-	
-
-
-	SDL_UnlockSurface(heightMap);
-	int cnt = 0;
-	for(int i = i1   ; i < i2  ; i +=sampleRate)
-	{
-		
-	    for(int j = j1-sampleRate  ; j < j2  + 2*sampleRate  ;  j += sampleRate)
-	    {
-		
-	    	model->addIndice(cnt);
-		model->addIndice(cnt  + (j2 -j1 + 3* sampleRate  )/ sampleRate );
-		cnt++;
-		
-	    }
-	    	
-	    	
-	    	
-		 model->newStripe();	
-		
-		
-	}
-	 cnt += (j2 -j1 + 3* sampleRate)/ sampleRate;
-	
-		for(int j = j1 ; j <= j2    ;  j += sampleRate)
-	    {
-	    	int i = i1;
-	    
-	    	 // To be fixed
-		 if(hm->hasColourMap)
-		 {
-		 r = (float)colours[3*j+2 + 3*i*(heightMap->w )];
-		 g = (float)colours[3*j+1 + 3*i*(heightMap->w)];
-		 b = (float)colours[3*j+0 + 3*i*(heightMap->w)];
-		 }
 		
 		model->addVertex(scaleX*(heightMap->h -i) + shiftX , shiftY ,scaleZ*(j) + shiftZ); // Top Right	
-		model->addNormal(normalVectorField[i][j].y,normalVectorField[i][j].z,normalVectorField[i][j].x);
-		model->addTexCoor((float)j /(texRate), (float)((i - sampleRate) %heightMap->h)/(texRate));
- 		model->addColor(r/255.0,g/255.0,b/255.0);		
-	
-	    }
-
-	        for(int j = j1  ; j <= j2    ;  j += sampleRate)
-	    {
-	    	int i = i1;
-	    	height = (float)(unsigned char) hm->heights[j +sampleRate+ i*(heightMap->w )];
-		height += (float)(unsigned char) hm->heights[j+ 1 + sampleRate + (i+1)*(heightMap->w )];
-		height +=  (float) (unsigned char) hm->heights[j -1+ sampleRate   + (i+1)*(heightMap->w )];
-		height +=  (float)(unsigned char)hm->heights[j +sampleRate+ (i+2)*(heightMap->w )];
-		height +=  (float)(unsigned char)hm->heights[j+sampleRate + (i)*(heightMap->w )];
-		height=height/5.0;
-		
-		model->addVertex(scaleX*(heightMap->h -i) + shiftX , ((double)(height)*scaleY) +shiftY ,scaleZ*(j) + shiftZ); // Top Right	
-		model->addNormal(normalVectorField[i][j].y,normalVectorField[i][j].z,normalVectorField[i][j].x);
-		model->addTexCoor((float)j /(texRate), (float)(i %heightMap->h)/(texRate));
- 		model->addColor(r/255.0,g/255.0,b/255.0);
-	    
-	    }
-	    
-	        
-	    
-	    for(int j = j1  ; j <= j2    ;  j += sampleRate)
-	    {
-	    	int i = i2;
-	    
-	    	 // To be fixed
-		 if(hm->hasColourMap)
-		 {
-		 r = (float)colours[3*j+2 + 3*i*(heightMap->w )];
-		 g = (float)colours[3*j+1 + 3*i*(heightMap->w)];
-		 b = (float)colours[3*j+0 + 3*i*(heightMap->w)];
-		 }
-		
-		model->addVertex(scaleX*(heightMap->h -i) + shiftX , shiftY ,scaleZ*(j) + shiftZ); // Top Right	
-		model->addNormal(normalVectorField[i][j].y,normalVectorField[i][j].z,normalVectorField[i][j].x);
+		model->addNormal(normalVectorField[i%heightMap->h][j%heightMap->w].y,normalVectorField[i%heightMap->h][j%heightMap->w].z,normalVectorField[i%heightMap->h][j%heightMap->w].x);
 		model->addTexCoor((float)j /(texRate), (float)((i+ sampleRate) %heightMap->h)/(texRate));
  		model->addColor(r/255.0,g/255.0,b/255.0);		
@@ -255,12 +262,12 @@
 	    {
 	    	int i = i2;
-	    	height = (float)(unsigned char) hm->heights[j +sampleRate+ i*(heightMap->w )];
-		height += (float)(unsigned char) hm->heights[j+ 1 + sampleRate + (i+1)*(heightMap->w )];
-		height +=  (float) (unsigned char) hm->heights[j -1+ sampleRate   + (i+1)*(heightMap->w )];
-		height +=  (float)(unsigned char)hm->heights[j +sampleRate+ (i+2)*(heightMap->w )];
-		height +=  (float)(unsigned char)hm->heights[j+sampleRate + (i)*(heightMap->w )];
+		height = (float)(unsigned char) hm->heights[(j +sampleRate+ i*(heightMap->w )) ];
+		height += (float)(unsigned char) hm->heights[(j+ 1 + sampleRate + (i+1)*(heightMap->w )) ];
+		height +=  (float) (unsigned char) hm->heights[(j -1+ sampleRate   + (i+1)*(heightMap->w ))];
+		height +=  (float)(unsigned char)hm->heights[(j +sampleRate+ (i+2)*(heightMap->w ))];
+		height +=  (float)(unsigned char)hm->heights[(j+sampleRate + (i)*(heightMap->w )) ];
 		height=height/5.0;
 		model->addVertex(scaleX*(heightMap->h -i) + shiftX , ((double)(height)*scaleY) +shiftY ,scaleZ*(j) + shiftZ); // Top Right	
-		model->addNormal(normalVectorField[i][j].y,normalVectorField[i][j].z,normalVectorField[i][j].x);
+		model->addNormal(normalVectorField[i%heightMap->h][j%heightMap->w].y,normalVectorField[i%heightMap->h][j%heightMap->w].z,normalVectorField[i%heightMap->h][j%heightMap->w].x);
 		model->addTexCoor((float)j /(texRate), (float)(i %heightMap->h)/(texRate));
  		model->addColor(r/255.0,g/255.0,b/255.0);
@@ -302,4 +309,5 @@
 	 
 	    
+	    SDL_UnlockSurface(hm->colourMap);
 	
 	 model->finalize();
@@ -416,4 +424,19 @@
 {
 	delete heightMap;
+	delete colourMap;
+	
+
+	for(int i=0;i <    heightMap->h/tileSize ; i++)
+	{
+	for(int j = 0; j < heightMap->w/ tileSize; j++)
+	{
+	 delete tiles [i][j];
+	}
+	}
+	for(int i=0;i <    heightMap->h/tileSize ; i++)
+	  delete[] tiles[i];
+	delete[] tiles;
+	
+	
 }
 
@@ -427,7 +450,7 @@
 
 //SetUp Arrays
-for(int i = 0; i < (heightMap->h - tileSize )/ tileSize; i ++)
-{
-	for(int j = 0; j < (heightMap->w - tileSize )/ tileSize; j ++)
+for(int i = 0; i < (heightMap->h  )/ tileSize; i ++)
+{
+	for(int j = 0; j < (heightMap->w )/ tileSize; j ++)
 	{
 	 
@@ -444,14 +467,14 @@
 Vector v = camera->getAbsCoor();
 
-int i_min = 1;
-int i_max = (heightMap->h - tileSize )/ tileSize;
-int j_min = 1;
-int j_max= (heightMap->w - tileSize) / tileSize;
-
-
-
-for(int i = 1; i <  i_max	 ; i ++)
-{
-	for(int j = 1; j < j_max ; j++)
+int i_min = 0;
+int i_max = (heightMap->h )/ tileSize;
+int j_min = 0;
+int j_max= (heightMap->w  ) / tileSize;
+
+
+
+for(int i = 0; i <  i_max	 ; i ++)
+{
+	for(int j = 0; j < j_max ; j++)
 	{
 	 tiles[i][j]->draw();
@@ -472,4 +495,15 @@
 
 
+
+// Initialize 
+for(int i=0; i< heightMap->h; i++)
+{
+	for(int j = 0; j> heightMap->w; j++)
+	{
+	Vector v = Vector(0.0, 1.0, 0.0);
+	 normalVectorField[i][j] = v;
+	}
+}
+
 // !!! Does not yet calculate the normals of some border points!!!!!
 
@@ -499,4 +533,7 @@
 }
 
+ 	
+
+
 }
 
@@ -522,5 +559,5 @@
 
  x -= offsetX;
- y -= offsetZ;
+ y -= offsetZ; 
  
  
@@ -528,8 +565,12 @@
  int yInt = (int)y / scaleZ;    y -= (float) ((int) y); /*yInt = heightMap->w - yInt;*/
  
- PRINTF(0)("xInt: %i, yInt: %i, x: %f, y: %f\n", xInt, yInt, x, y);
+ //PRINTF(0)("xInt: %i, yInt: %i, x: %f, y: %f\n", xInt, yInt, x, y);
  
  if(xInt <= 0 || xInt >= heightMap->h || yInt <= 0 || yInt >= heightMap->w  ) return 0;
- 
+ if( y >= 0.5*x)
+ {
+	// Check for ... 
+ }
+
  float height = heights[yInt + (xInt)*heightMap->w]*scaleY;
  
@@ -543,5 +584,5 @@
    PRINTF(0)("c: %f \n" ,c);
  
- height += ( (a/c)*(x) + (b/c)*(y));
+ height -= ( (a/c)*(x) + (b/c)*(y));
   
  PRINTF(0)("height: %f \n" ,height );
Index: /branches/height_map_merge/src/lib/graphics/importer/height_map.h
===================================================================
--- /branches/height_map_merge/src/lib/graphics/importer/height_map.h	(revision 6938)
+++ /branches/height_map_merge/src/lib/graphics/importer/height_map.h	(revision 6939)
@@ -38,4 +38,6 @@
 Tile(int i1, int j1, int i2, int j2, HeightMap* hm ) ;
 Tile();
+float x;
+float z;
 ~Tile();
 
@@ -43,4 +45,5 @@
 
 private:
+HeightMap* hmref;
 VertexArrayModel* highResModel;
 VertexArrayModel* lowResModel; 
Index: /branches/height_map_merge/src/lib/graphics/importer/vertex_array_model.cc
===================================================================
--- /branches/height_map_merge/src/lib/graphics/importer/vertex_array_model.cc	(revision 6938)
+++ /branches/height_map_merge/src/lib/graphics/importer/vertex_array_model.cc	(revision 6939)
@@ -139,4 +139,6 @@
   glColorMaterial ( GL_FRONT_AND_BACK, GL_EMISSION ) ;
   glEnable (GL_COLOR_MATERIAL) ;
+  
+
 
 
Index: /branches/height_map_merge/src/world_entities/terrain.cc
===================================================================
--- /branches/height_map_merge/src/world_entities/terrain.cc	(revision 6938)
+++ /branches/height_map_merge/src/world_entities/terrain.cc	(revision 6939)
@@ -49,7 +49,7 @@
    heightMapMaterial->setIllum(0.2);
 
-   heightMapMaterial->setDiffuse(1.0,1.0,1.0);
-   heightMapMaterial->setAmbient(1.0,1.0,1.0 );
-   heightMapMaterial->setSpecular(1.0,1.0,1.0);
+   heightMapMaterial->setDiffuse(0.4,0.4,0.4);
+   heightMapMaterial->setAmbient(0.4,0.4,0.4 );
+   heightMapMaterial->setSpecular(0.4,0.4,0.4);
    heightMapMaterial->setShininess(.5);
    heightMapMaterial->setTransparency(1.0);
@@ -112,4 +112,7 @@
     ResourceManager::getInstance()->unload(this->vegetation);
   }
+  
+  if(this->heightMap)
+  	delete heightMap;
 }
 
@@ -156,5 +159,5 @@
 
   this->heightMap = new HeightMap(hmName, hmColorName);
-  heightMap->scale(Vector(23.0f,1.1f,23.0f));
+  heightMap->scale(Vector(43.0f,4.7f,43.0f));
   heightMap->setAbsCoor(this->getAbsCoor());
   heightMap->load();
@@ -171,5 +174,5 @@
 
 delete this->heightMapMaterial;
-/*   
+
    this->heightMapMaterial = new Material(); 
    heightMapMaterial->setTransparency(1.0);
@@ -191,5 +194,5 @@
    heightMapMaterial->setSpecularMap(textureName); 	
  
-*/
+
 
 }
@@ -258,15 +261,18 @@
 glLoadIdentity();
  Vector camera =   State::getCamera()->getAbsCoor(); // Go on here ..........!!!
+    
+    /*
     float height =    heightMap->getHeight(camera.x, camera.z);
     
+  
   glEnable (GL_COLOR_MATERIAL) ;
     glBegin(GL_QUADS);            // Draw The Cube Using quads
     glColor3f(0.0f,1.0f,0.0f);  // Color Blue
-    glVertex3f(camera.x + 63.0f,heightMap->getHeight(camera.x+63.0f, camera.z-10.0f)+13.0f,camera.z-10.0f);      // Top Right Of The Quad (Top)
-    glVertex3f(camera.x-63.0f, heightMap->getHeight(camera.x+63.0f, camera.z-10.0f)+13.0f,camera.z-10.0f);      // Top Left Of The Quad (Top)
-    glVertex3f(camera.x-63.0f, heightMap->getHeight(camera.x+63.0f, camera.z+10.0f)+13.0f, camera.z+10.0f);      // Bottom Left Of The Quad (Top)
-    glVertex3f(camera.x+ 63.0f, heightMap->getHeight(camera.x+63.0f, camera.z+10.0f)+13.0f, camera.z+10.0f);      // Bottom Right Of The Quad (Top)
+    glVertex3f(camera.x + 63.0f,Terrain->getHeight(camera.x+63.0f, camera.z-10.0f)+13.0f,camera.z-10.0f);      // Top Right Of The Quad (Top)
+    glVertex3f(camera.x-63.0f, getHeight(camera.x+63.0f, camera.z-10.0f)+13.0f,camera.z-10.0f);      // Top Left Of The Quad (Top)
+    glVertex3f(camera.x-63.0f, getHeight(camera.x+63.0f, camera.z+10.0f)+13.0f, camera.z+10.0f);      // Bottom Left Of The Quad (Top)
+    glVertex3f(camera.x+ 63.0f, getHeight(camera.x+63.0f, camera.z+10.0f)+13.0f, camera.z+10.0f);      // Bottom Right Of The Quad (Top)
    glEnd();                      // End Drawing The Plan
-   
+   */
     
 glPopMatrix();